!--------( MKMODEL : generate source data for model study )--------
  real :: f(51,51), h(51,51), t(71,71)
  character(80) :: wdr, flog, fsurf, fnam1, fnam2, fnam3
  character(20) :: sdtm
  real,parameter :: obsalt = 20., srctop = 0.
!     Obs. alt. = 20(m) const. = hor. mesh size
!     Source top surface alt. = 0(m)
!     Obs. area :  1000(m) x 1000(m) :  51x51 mesh
!     Assumed source area :  1400(m) x 1400(m) : 71x71 mesh
  call premsg('MKMODEL')
  call opnpin()
  ldr = lwkdir(50,wdr) + 1
  flog = wdr;  fsurf = wdr;  fnam1 = wdr;  fnam2 = wdr;  fnam3 = wdr
  call gparma('Enter LOG filename ==> ', 81-ldr, flog(ldr:80))
  call gparma('Enter Src surface data outfile  ==> ', 81-ldr, fsurf(ldr:80))
  open(10,file=fsurf,status='new')
  call gparma('Enter Model1 anom data outfile  ==> ', 81-ldr, fnam1(ldr:80))
  open(1,file=fnam1,status='new')
  call gparma('Enter Model2 anom data outfile  ==> ', 81-ldr, fnam2(ldr:80))
  open(2,file=fnam2,status='new')
  call gparma('Enter Model3 anom data outfile  ==> ', 81-ldr, fnam3(ldr:80))
  open(3,file=fnam3,status='new')
  write(6,'(a)') '----------------------------------------'
  write(6,'(a)') 'MKMODEL'
  write(6,'(a,a)') ' Src surface alt outfile  : ', fsurf(1:lrtrim(fsurf))
  write(6,'(a,a)') ' Model1 anom output file  : ', fnam1(1:lrtrim(fnam1))
  write(6,'(a,a)') ' Model2 anom output file  : ', fnam2(1:lrtrim(fnam2))
  write(6,'(a,a)') ' Model3 anom output file  : ', fnam3(1:lrtrim(fnam3))

  do j=1,51;  do i=1,51
    h(i,j) = obsalt
  enddo;  enddo
  do j=1,71;  do i=1,71
    t(i,j) = srctop
  enddo;  enddo

  write(10,'(a8,4x,i4,4i8)') 'modelalt', 53, 0,8100,0,0
  write(10,'(2i12,4i6,f8.1,f8.0)') 3999300,499300, 20,20,71,71, 9999.9,  -1.
  do j=1,71
    write(10,'((f7.1,9(1x,f7.1)))') (t(i,j),i=1,71)
  enddo
  close(10)

  call magafd(90., 0., 90., 0.)
  call mprism(4.8, 500., 200., 500., 200., 150., 200.)
  do j=1,51
    y = float(j*20 - 20)
    do i=1,51
      x = float(i*20 - 20)
      f(i,j) = calma(x, y, -h(i,j))
    enddo
  enddo
  write(1,'(a8,4x,i4,4i8)') 'model1  ', 53, 0,8100,0,0
  write(1,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, 0.
  do j=1,51
    write(1,'((f7.1,9(1x,f7.1)))') (f(i,j),i=1,51)
  enddo
  write(1,'(a8,4x,i4,4i8)') 'model1  ', 53, 0,8100,0,0
  write(1,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, -1.
  do j=1,51
    write(1,'((f7.1,9(1x,f7.1)))') (h(i,j),i=1,51)
  enddo
  close(1)

  do j=1,51;  do i=1,51
    f(i,j) = 0.
  enddo;  enddo
  call magafd(75., 25., 75., 25.)
  cx = 500.;  cy = 620.;  z = 55.
  do k=1,30
    call mhrect(2.4, cx, 500., cy, 150., z, 10.)
    do j=1,51
      y = float(j*20 - 20)
      do i=1,51
        x = float(i*20 - 20)
        f(i,j) = f(i,j) + calma(x, y, -h(i,j))
      enddo
    enddo
    cy = cy - 10.
    z = z + 10.
  enddo
  write(2,'(a8,4x,i4,4i8)') 'model2  ', 53, 0,8100,0,0
  write(2,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, 0.
  do j=1,51
    write(2,'((f7.1,9(1x,f7.1)))') (f(i,j),i=1,51)
  enddo
  write(2,'(a8,4x,i4,4i8)') 'model2  ', 53, 0,8100,0,0
  write(2,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, -1.
  do j=1,51
    write(2,'((f7.1,9(1x,f7.1)))') (h(i,j),i=1,51)
  enddo
  close(2)

  do j=1,51;  do i=1,51
    f(i,j) = 0.
  enddo;  enddo
  call magafd(45., 45., 45., 45.)
  cx = 500.;  cy = 670.;  ry = 150.;  z = 55.
  do k=1,20
    call mhrect(2.4, cx, 500., cy, ry, z, 10.)
    do j=1,51
      y = float(j*20 - 20)
      do i=1,51
        x = float(i*20 - 20)
        f(i,j) = f(i,j) + calma(x, y, -20.)
      enddo
    enddo
    cy = cy - 10.
    z = z + 10.
    if (k >= 15) then
      if (k == 15) then
        ry = ry - 15.;  cy = cy + 7.5
      else
        ry = ry - 30.;  cy = cy + 15.
      endif
    endif
  enddo
  cy = 352.5;  ry = 15.;  z = 155.
  do k=1,20
    call mhrect(2.4, cx, 500., cy, ry, z, 10.)
    do j=1,51
      y = float(j*20 - 20)
      do i=1,51
        x = float(i*20 - 20)
        f(i,j) = f(i,j) + calma(x, y, -h(i,j))
      enddo
    enddo
    cy = cy - 10.
    z = z + 10.
    if (k.le.5) then
      if (k.eq.5) then
        ry = ry + 15.;  cy = cy + 7.5
      else
        ry = ry + 30.;  cy = cy + 15.
      endif
    endif
  enddo
  write(3,'(a8,4x,i4,4i8)') 'model3  ', 53, 0,8100,0,0
  write(3,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, 0.
  do j=1,51
    write(3,'((f7.1,9(1x,f7.1)))') (f(i,j),i=1,51)
  enddo
  write(3,'(a8,4x,i4,4i8)') 'model3  ', 53, 0,8100,0,0
  write(3,'(2i12,4i6,f8.1,f8.0)') 3999500,499500, 20,20,51,51, 9999.9, -1.
  do j=1,51
    write(3,'((f7.1,9(1x,f7.1)))') (h(i,j),i=1,51)
  enddo
  close(3)

  if(flog(ldr:ldr) /= ' ') then
    open(99,file=flog,access='append')
    write(99,'(//a)') 'MKMODEL'
    write(99,'(a,a)') ' Src surface alt outfile  : ', fsurf(1:lrtrim(fsurf))
    write(99,'(a,a)') ' Model1 anom output file  : ', fnam1(1:lrtrim(fnam1))
    write(99,'(a,a)') ' Model2 anom output file  : ', fnam2(1:lrtrim(fnam2))
    write(99,'(a,a)') ' Model3 anom output file  : ', fnam3(1:lrtrim(fnam3))
    call strdtm(sdtm)
    write(99,'(a,a,a)') '=============== ', sdtm, '==============='
    close(99)
  endif
  stop
  end
